package com.fr.plugin.heatpointmapbox;

import com.fr.design.gui.frpane.AttributeChangeListener;
import com.fr.design.mainframe.chart.AbstractChartAttrPane;
import com.fr.design.mainframe.chart.gui.data.report.AbstractReportDataContentPane;
import com.fr.extended.chart.AbstractExtendedChartTableDataPane;
import com.fr.extended.chart.AbstractExtendedChartUIProvider;
import com.fr.plugin.heatpointmapbox.data.HeatPointMapDataPane;
import com.fr.plugin.heatpointmapbox.data.HeatPointMapReportDataPane;
import com.fr.plugin.heatpointmapbox.ui.HeatPointMapStylePane;

/**
 * @author xx
 * @date 2022/8/19
 */
public class HeatPointMapChartUI extends AbstractExtendedChartUIProvider {

	@Override
	protected AbstractExtendedChartTableDataPane getTableDataSourcePane() {
		return new HeatPointMapDataPane();
	}

	@Override
	protected AbstractReportDataContentPane getReportDataSourcePane() {
		return new HeatPointMapReportDataPane();
	}

	@Override
	public String getIconPath() {
		return "com/fr/plugin/heatpointmapbox/images/icon.png";
	}

	@Override
	public AbstractChartAttrPane[] getAttrPaneArray(AttributeChangeListener attributeChangeListener) {
		return new AbstractChartAttrPane[]{
				new HeatPointMapStylePane(attributeChangeListener)
		};
	}

	@Override
	public String[] getDemoImagePath() {
		return new String[]{"com/fr/plugin/heatpointmapbox/images/demo.png"};
	}
}
