package com.fr.plugin.heatpointmapbox.data;

import com.fr.extended.chart.AbstractDataConfig;
import com.fr.extended.chart.ExtendedField;
import com.fr.stable.AssistUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

/**
 * @author xx
 * @date 2022/12/25
 */
public class HeatPointMapDataConfig extends AbstractDataConfig {

    private ExtendedField layertype = new ExtendedField();
    private ExtendedField datatype = new ExtendedField();
    private ExtendedField lng = new ExtendedField();
    private ExtendedField lat = new ExtendedField();
    private ExtendedField name = new ExtendedField();
    private ExtendedField val = new ExtendedField();
    private ExtendedField desc = new ExtendedField();

    @Override
    protected void readAttr(XMLableReader xmLableReader) {
        readExtendedField(layertype, "layertype", xmLableReader);
        readExtendedField(datatype, "datatype", xmLableReader);
        readExtendedField(lng, "lng", xmLableReader);
        readExtendedField(lat, "lat", xmLableReader);
        readExtendedField(name, "name", xmLableReader);
        readExtendedField(val, "val", xmLableReader);
        readExtendedField(desc, "desc", xmLableReader);
    }

    @Override
    protected void writeAttr(XMLPrintWriter xmlPrintWriter) {
        writeExtendedField(layertype, "layertype", xmlPrintWriter);
        writeExtendedField(datatype, "datatype", xmlPrintWriter);
        writeExtendedField(lng, "lng", xmlPrintWriter);
        writeExtendedField(lat, "lat", xmlPrintWriter);
        writeExtendedField(name, "name", xmlPrintWriter);
        writeExtendedField(val, "val", xmlPrintWriter);
        writeExtendedField(desc, "desc", xmlPrintWriter);
    }

    @Override
    public ExtendedField[] dataSetFields() {
        return new ExtendedField[]{
                layertype,
                datatype,
                lng,
                lat,
                name,
                val,
                desc
        };
    }

    @Override
    public HeatPointMapDataConfig clone() throws CloneNotSupportedException {
        HeatPointMapDataConfig result = new HeatPointMapDataConfig();
        result.setLayertype(this.getLayertype().clone());
        result.setDatatype(this.getDatatype().clone());
        result.setLng(this.getLng().clone());
        result.setLat(this.getLat().clone());
        result.setName(this.getName().clone());
        result.setVal(this.getVal().clone());
        result.setDesc(this.getDesc().clone());
        return result;
    }

    @Override
    public int hashCode() {
        return super.hashCode() + AssistUtils.hashCode(this.getLayertype(), this.getDatatype(), this.getLng(), this.getLat(), this.getName(),this.getVal(),this.getDesc());
    }

    @Override
    public boolean equals(Object obj) {
        return super.equals(obj)
                && obj instanceof HeatPointMapDataConfig
                && AssistUtils.equals(this.getLayertype(), ((HeatPointMapDataConfig) obj).getLayertype())
                && AssistUtils.equals(this.getDatatype(), ((HeatPointMapDataConfig) obj).getDatatype())
                && AssistUtils.equals(this.getLng(), ((HeatPointMapDataConfig) obj).getLng())
                && AssistUtils.equals(this.getLat(), ((HeatPointMapDataConfig) obj).getLat())
                && AssistUtils.equals(this.getName(), ((HeatPointMapDataConfig) obj).getName())
                && AssistUtils.equals(this.getVal(), ((HeatPointMapDataConfig) obj).getVal())
                && AssistUtils.equals(this.getDesc(), ((HeatPointMapDataConfig) obj).getDesc())
                ;
    }

    public ExtendedField getDatatype() {
        return datatype;
    }

    public void setDatatype(ExtendedField datatype) {
        this.datatype = datatype;
    }

    public ExtendedField getLayertype() {
        return layertype;
    }

    public void setLayertype(ExtendedField layertype) {
        this.layertype = layertype;
    }

    public ExtendedField getLng() {
        return lng;
    }

    public void setLng(ExtendedField lng) {
        this.lng = lng;
    }

    public ExtendedField getLat() {
        return lat;
    }

    public void setLat(ExtendedField lat) {
        this.lat = lat;
    }

    public ExtendedField getName() {
        return name;
    }

    public void setName(ExtendedField name) {
        this.name = name;
    }

    public ExtendedField getVal() {
        return val;
    }

    public void setVal(ExtendedField val) {
        this.val = val;
    }

    public ExtendedField getDesc() {
        return desc;
    }

    public void setDesc(ExtendedField desc) {
        this.desc = desc;
    }

}
