package com.fr.plugin.heatpointmapbox.data;

import com.fr.design.gui.icombobox.UIComboBox;
import com.fr.design.i18n.Toolkit;
import com.fr.extended.chart.AbstractExtendedChartTableDataPane;

/**
 * @author xx
 * @date 2022/8/25
 */
public class HeatPointMapDataPane extends AbstractExtendedChartTableDataPane<HeatPointMapDataConfig> {

    private UIComboBox layertype;
    private UIComboBox datatype;
    private UIComboBox lng;
    private UIComboBox lat;
    private UIComboBox name;
    private UIComboBox val;
    private UIComboBox desc;


    @Override
    protected String[] fieldLabels() {
        return new String[]{
                Toolkit.i18nText("Plugin_HeatPointMap_layertype"),
                Toolkit.i18nText("Plugin_HeatPointMap_datatype"),
                Toolkit.i18nText("Plugin_HeatPointMap_lng"),
                Toolkit.i18nText("Plugin_HeatPointMap_lat"),
                Toolkit.i18nText("Plugin_HeatPointMap_name"),
                Toolkit.i18nText("Plugin_HeatPointMap_val"),
                Toolkit.i18nText("Plugin_HeatPointMap_desc")
        };
    }

    @Override
    protected UIComboBox[] filedComboBoxes() {
        if (null == datatype) {
            layertype = new UIComboBox();
            datatype = new UIComboBox();
            lng = new UIComboBox();
            lat = new UIComboBox();
            name = new UIComboBox();
            val = new UIComboBox();
            desc = new UIComboBox();
        }
        return new UIComboBox[]{
                layertype, datatype, lng, lat, name, val, desc
        };
    }

    @Override
    protected void populate(HeatPointMapDataConfig dataConfig) {
        populateField(layertype, dataConfig.getLayertype());
        populateField(datatype, dataConfig.getDatatype());
        populateField(lng, dataConfig.getLng());
        populateField(lat, dataConfig.getLat());
        populateField(name, dataConfig.getName());
        populateField(val, dataConfig.getVal());
        populateField(desc, dataConfig.getDesc());
    }

    @Override
    protected HeatPointMapDataConfig update() {
        HeatPointMapDataConfig dataConfig = new HeatPointMapDataConfig();
        updateField(layertype, dataConfig.getLayertype());
        updateField(datatype, dataConfig.getDatatype());
        updateField(lng, dataConfig.getLng());
        updateField(lat, dataConfig.getLat());
        updateField(name, dataConfig.getName());
        updateField(val, dataConfig.getVal());
        updateField(desc, dataConfig.getDesc());
        return dataConfig;
    }
}
