package com.fr.plugin.heatpointmapbox.data;

import com.fr.design.formula.TinyFormulaPane;
import com.fr.design.i18n.Toolkit;
import com.fr.extended.chart.AbstractExtendedChartReportDataPane;

/**
 * @author xx
 * @date 2022/8/25
 */
public class HeatPointMapReportDataPane extends AbstractExtendedChartReportDataPane<HeatPointMapDataConfig> {

    private TinyFormulaPane layertype;
    private TinyFormulaPane datatype;
    private TinyFormulaPane lng;
    private TinyFormulaPane lat;
    private TinyFormulaPane name;
    private TinyFormulaPane val;
    private TinyFormulaPane desc;


    @Override
    protected String[] fieldLabel() {
        return new String[]{
                Toolkit.i18nText("Plugin_HeatPointMap_layertype"),
                Toolkit.i18nText("Plugin_HeatPointMap_datatype"),
                Toolkit.i18nText("Plugin_HeatPointMap_lng"),
                Toolkit.i18nText("Plugin_HeatPointMap_lat"),
                Toolkit.i18nText("Plugin_HeatPointMap_name"),
                Toolkit.i18nText("Plugin_HeatPointMap_val"),
                Toolkit.i18nText("Plugin_HeatPointMap_desc")
        };
    }

    @Override
    protected TinyFormulaPane[] formulaPanes() {
        if (null == datatype) {
            layertype = new TinyFormulaPane();
            datatype = new TinyFormulaPane();
            lng = new TinyFormulaPane();
            lat = new TinyFormulaPane();
            name = new TinyFormulaPane();
            val = new TinyFormulaPane();
            desc = new TinyFormulaPane();
        }
        return new TinyFormulaPane[]{
                layertype, datatype, lng, lat, name, val, desc
        };
    }

    @Override
    protected void populate(HeatPointMapDataConfig dataConfig) {
        populateField(layertype, dataConfig.getLayertype());
        populateField(datatype, dataConfig.getDatatype());
        populateField(lng, dataConfig.getLng());
        populateField(lat, dataConfig.getLat());
        populateField(name, dataConfig.getName());
        populateField(val, dataConfig.getVal());
        populateField(desc, dataConfig.getDesc());
    }

    @Override
    protected HeatPointMapDataConfig update() {
        HeatPointMapDataConfig dataConfig = new HeatPointMapDataConfig();
        updateField(layertype, dataConfig.getLayertype());
        updateField(datatype, dataConfig.getDatatype());
        updateField(lng, dataConfig.getLng());
        updateField(lat, dataConfig.getLat());
        updateField(name, dataConfig.getName());
        updateField(val, dataConfig.getVal());
        updateField(desc, dataConfig.getDesc());
        return dataConfig;
    }
}
