package com.fr.plugin.heatpointmapbox.ui;


import com.fr.design.gui.icombobox.ColorSchemeComboBox;
import com.fr.design.i18n.Toolkit;

import java.util.Map;

/**
 * @author xx
 * @date 2022/10/11
 */
public class CustomColorSchemeComboBox extends ColorSchemeComboBox {

    @Override
    protected Map<String, ColorInfo> getColorSchemesFromConfig() {
        Map<String, ColorInfo> schemesConfig = super.getColorSchemesFromConfig();
        schemesConfig.remove(Toolkit.i18nText("Fine-Design_Chart_Custom_Gradient"));
        return schemesConfig;
    }

    @Override
    public SelectType getSelectType() {
        int var1 = this.getSelectedIndex();
        int var2 = this.getItemCount();
        if (var1 == var2 - 1) {
            return SelectType.COMBINATION_COLOR;
        } else {
            return SelectType.NORMAL;
        }
    }

    @Override
    public void setSelectType(SelectType var1) {
        int var2 = this.getItemCount();
        switch(var1) {
            case DEFAULT:
                this.setSelectedIndex(0);
                break;
            case COMBINATION_COLOR:
                this.setSelectedIndex(var2 - 1);
        }

    }
}
