package com.fr.plugin.heatpointmapbox.ui;

import com.fr.design.i18n.Toolkit;
import com.fr.design.layout.TableLayout;
import com.fr.design.layout.TableLayoutHelper;
import com.fr.extended.chart.ExtendedScrollPane;
import com.fr.plugin.heatpointmapbox.HeatPointMapChart;
import com.fr.van.chart.designer.TableLayout4VanChartHelper;

import javax.swing.*;
import java.awt.*;

public class HeatPointMapStyleOtherPane extends ExtendedScrollPane<HeatPointMapChart> {

    private HeatPointMapHyperLink hyperLink;
    private HeatPointMapPointCondListPane pointCondListPane;

    @Override
    protected JPanel createContentPane() {
        return new ContentPane();
    }

    @Override
    public void populateBean(HeatPointMapChart chart) {
        hyperLink.populateBean(chart);
        pointCondListPane.populateStyle(chart);
    }

    @Override
    public void updateBean(HeatPointMapChart chart) {
        hyperLink.updateBean(chart);
        pointCondListPane.updateStyle(chart);
    }

    @Override
    protected String title4PopupWindow() {
        return Toolkit.i18nText("Plugin-HeatPointMap-otherstitle");
    }

    private class ContentPane extends JPanel {
        public ContentPane() {
            initComponents();
        }

        private void initComponents() {
            this.setLayout(new BorderLayout());

            JPanel linkPane = createLinkPane();
            JPanel pointCondPane = createPointStyleCondPane();

            double p = TableLayout.PREFERRED;
            double f = TableLayout.FILL;
            double[] columnSize = {f};
            double[] rowSize = {p, p, p};
            Component[][] acomponents = new Component[][]{
                    new Component[]{linkPane},
                    new Component[]{pointCondPane}
            };
            JPanel panel = TableLayoutHelper.createTableLayoutPane(acomponents,rowSize,columnSize);

            this.add(panel,BorderLayout.CENTER);
            this.setVisible(true);
        }
    }

    private JPanel createLinkPane() {
        this.hyperLink = new HeatPointMapHyperLink();

        Component[][] components = new Component[][]{
                new Component[]{hyperLink}
        };
        double p = TableLayout.PREFERRED;
        double[] columnSize = {TableLayout.FILL};
        double[] rowSize = {p, p};
        JPanel panel = TableLayout4VanChartHelper.createGapTableLayoutPane(components, rowSize, columnSize);
        return TableLayout4VanChartHelper.createExpandablePaneWithTitle(Toolkit.i18nText("Plugin-HeatPointMap-LinkExpand"), panel);
    }

    private JPanel createPointStyleCondPane() {
        this.pointCondListPane = new HeatPointMapPointCondListPane();
        return TableLayout4VanChartHelper.createExpandablePaneWithTitle(Toolkit.i18nText("Plugin-HeatPointMap-pointStyleCondExpand"), this.pointCondListPane);
    }

}
