package com.fr.plugin.heatpointmapbox.ui;

import com.fr.design.gui.frpane.AttributeChangeListener;
import com.fr.extended.chart.AbstractExtendedStylePane;
import com.fr.extended.chart.ExtendedScrollPane;
import com.fr.plugin.heatpointmapbox.HeatPointMapChart;

import java.util.ArrayList;
import java.util.List;

/**
 * @author xx
 * @date 2022/8/19
 */
public class HeatPointMapStylePane extends AbstractExtendedStylePane<HeatPointMapChart> {

    private AttributeChangeListener attributeChangeListener;

    public HeatPointMapStylePane(){
        super();
    }
    public HeatPointMapStylePane(AttributeChangeListener attributeChangeListener){
        super(attributeChangeListener);
    }

    @Override
    protected List<ExtendedScrollPane<HeatPointMapChart>> initPaneList() {
        List<ExtendedScrollPane<HeatPointMapChart>> list = new ArrayList<ExtendedScrollPane<HeatPointMapChart>>();
        list.add(new HeatPointMapStyleTitlePane());
        list.add(new HeatPointMapStyleBaseMapPane());
        list.add(new HeatPointMapStylePointMapPane());
        list.add(new HeatPointMapStyleHeatMapPane());
        list.add(new HeatPointMapStyleLegendPane());
        list.add(new HeatPointMapStyleLabelsPane());
        list.add(new HeatPointMapStyleTipsPane());
        list.add(new HeatPointMapStyleOtherPane());
        return list;
    }
}
